#include <alloc.h>
#include <conio.h>
#include <dir.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "mouse.h"
#include "tge.h"

#ifndef __TURBOC__
#define random(num)		(rand() % num)
#define randomize()     	srand((unsigned)time(NULL))
#endif

#define ESC	27

void lineDemo(void);
void putPixelDemo(void);
void putImageDemo(void);
void drawRectDemo(void);
void filledRectDemo(void);
void ellipseDemo(void);
void filledEllipseDemo(void);
void circleDemo(void);
void filledCircleDemo(void);
void paletteDemo(void);
void mouseDemo(void);
void cycleColour(int *colour, int *increment);
void forceExtension(char *filename, char *extension);
void signOff(void);

unsigned char tgeLogo[] = {
  24,0,9,0,
  0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,
  0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,
  0,0,1,1,0,0,0,0,1,1,0,0,1,1,1,0,1,1,1,1,1,0,0,0,
  0,0,1,1,0,0,0,0,1,1,0,0,0,1,1,0,1,1,1,1,0,0,0,0,
  0,1,1,0,0,0,0,1,1,0,0,0,0,1,0,1,1,0,0,0,0,0,0,0,
  0,1,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,
  1,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0
};

int count;
int colour;
int maxx, maxy;
unsigned maxColour;
void far *bground;


void main(int argc, char *argv[])
{
  char filename[80];

  if (argc < 2)				/* Parse command line */
  {
    printf("TGEDEMO v1.2  Copyright (c) 1993 by Matthew Hildebrand\n\n"
	   "    Usage:  TGEDEMO driver\n\n");
    exit(1);
  }

  strcpy(filename, argv[1]);
  forceExtension(filename, ".DRV");	/* Load the specified driver */
  if (!loadGraphDriver(filename))
  {
    printf("Error loading \"%s\".\n\n", filename);
    exit(1);
  }

  maxx = _grSystemDrv->maxx;		/* set up variables */
  maxy = _grSystemDrv->maxy;
  maxColour = _grSystemDrv->maxColour;

  bground = farmalloc(imageSize(0,0,23,8));

  if (!initGraphics())			/* initialize graphics mode */
  {
    printf("Unable to initialize graphics hardware.\n\n");
    exit(1);
  }

  randomize();
  lineDemo();				/* run the demos */
  putPixelDemo();
  putImageDemo();
  drawRectDemo();
  filledRectDemo();
  ellipseDemo();
  filledEllipseDemo();
  circleDemo();
  filledCircleDemo();
  paletteDemo();
  mouseDemo();

  deInitGraphics();			/* restore text and quit */
  unloadGraphDriver();
  signOff();
}

void lineDemo(void)
{
  for (; !kbhit();)
    line(random(maxx+1), random(maxy+1), random(maxx+1), random(maxy+1),
    		random(maxColour+1));

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  colour = random(maxColour+1);
  for (count=maxx; count>=0; count-=2)
  {
    line(0, 0, maxx-count, maxy, colour);
    line(maxx, maxy, count, 0, colour);
  }
  clearGraphics(random(maxColour+1));
}

void putPixelDemo(void)
{
  for (; !kbhit();)
  {
    for (count=0; count<2000; count++)
      putPixel(random(maxx+1), random(maxy+1), random(maxColour+1));
  }

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }
}

void putImageDemo(void)
{
  int x, y;

  x = (maxx+1) / 2;
  y = (maxy+1) / 2;

  while (!kbhit())
  {
    getImage(x, y, x+23, y+8, bground);
    putImage(x, y, tgeLogo);
    putImage(x, y, bground);

    if (random(201) >= 100)
      x = x<maxx ? x+1 : x;
    else
      x = x ? x-1 : x;

    if (random(201) >= 100)
      y = y<maxy ? y+1 : y;
    else
      y = y ? y-1 : y;
  }

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  clearGraphics(random(maxColour+1));
}

void drawRectDemo(void)
{
  while (!kbhit())
    drawRect(random(maxx+1), random(maxy+1), random(maxx+1),
    		random(maxy+1), random(maxColour+1));

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  clearGraphics(random(maxColour+1));
}

void filledRectDemo(void)
{
  while (!kbhit())
    filledRect(random(maxx+1), random(maxy+1), random(maxx+1),
    		random(maxy+1), random(maxColour+1));

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  clearGraphics(random(maxColour+1));
}

void ellipseDemo(void)
{
  while (!kbhit())
    ellipse(random(maxx+1), random(maxy+1), random(maxx/8)*2+10,
    		random(maxy/8)*2+10, random(maxColour+1));

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  clearGraphics(random(maxColour+1));
}

void filledEllipseDemo(void)
{
  while (!kbhit())
    filledEllipse(random(maxx+1), random(maxy+1), random(maxx/8)*2+10,
    	random(maxy/8)*2+10, random(maxColour+1));

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  clearGraphics(random(maxColour+1));
}

void circleDemo(void)
{
  while (!kbhit())
    circle(random(maxx+1), random(maxy+1), random(maxx/8)+10,
    		random(maxColour+1));

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  clearGraphics(random(maxColour+1));
}

void filledCircleDemo(void)
{
  while (!kbhit())
    filledCircle(random(maxx+1), random(maxy+1), random(maxx/8)+10,
    		random(maxColour+1));

  if (getch() == ESC)
  {
    deInitGraphics();
    unloadGraphDriver();
    exit(0);
  }

  clearGraphics(0);
}


#define MAXINC	7

void paletteDemo(void)
{
  int redInc, greenInc, blueInc;
  int red=0, green=0, blue=0;
  colour = 1;

  redInc = random(MAXINC);
  redInc++;
  greenInc = random(MAXINC);
  greenInc++;
  blueInc = random(MAXINC);
  blueInc++;

  for (count=maxx; count>=0&&!kbhit(); count-=2) {
    line(0, 0, maxx-count, maxy, colour);
    line(maxx, maxy, count, 0, colour);
    cycleColour(&red, &redInc);
    cycleColour(&green, &greenInc);
    cycleColour(&blue, &blueInc);
    setPaletteReg(0, red, green, blue);
  }

  if (kbhit())
    getch();

  clearGraphics(1);
}

void cycleColour(int *colour, int *increment)
{
  *colour += *increment;

  if (*colour < 0)
  {
    *colour = 0;
    *increment = random(MAXINC) + 1;
  }
  else if (*colour > 255)
  {
    *colour = 255;
    *increment *= -1;
  }
}

void mouseDemo(void)
{
  int pointerNum;

  if (!resetMouse())			/* check if mouse is installed */
  {
    deInitGraphics();
    unloadGraphDriver();
    printf("Microsoft or compatible mouse not detected.\n"
           "The demo for definable, device-independent pointers will not be run.\n\n"
	   "Press a key to continue...");
    getch();
    clrscr();
    signOff();
    exit(0);
  }

  initNewMouse(putImageInv, putImage, getImage); /* initialize new mouse handler */
  setHorizLimitsMouse(0, maxx);
  setVertLimitsMouse(0, maxy);
  setPosMouse(maxx/2, maxy/2);
  pointerNum = ARROW_POINTER;
  setupMousePointer(pointerNum);
  showMouse();

  for (; !kbhit();)			/* main loop */
  {
    if (buttonMouse() && pointerNum!=TARGET_POINTER)
    {
      pointerNum = TARGET_POINTER;
      setupMousePointer(pointerNum);
    }
    else if (!buttonMouse() && pointerNum==TARGET_POINTER)
    {
      pointerNum = ARROW_POINTER;
      setupMousePointer(pointerNum);
    }
  }
  getch();				/* flush keyboard buffer */

  deInitNewMouse();			/* shut off new mouse handler */
}

void forceExtension(char *filename, char *extention)
{
  char fileDrive[MAXDRIVE];
  char fileDir[MAXDIR];
  char fileFile[MAXFILE];
  char fileExt[MAXEXT];

  fnsplit(filename, fileDrive, fileDir, fileFile, fileExt);

  if (strcmpi(fileExt, extention))
    fnmerge(filename, fileDrive, fileDir, fileFile, extention);
}

void signOff(void)
{
#ifndef __POWERC
  static char notice[] = {
    "Ŀ"
    " The Graphics Engine v1.10 Demo  Copyright (c) 1993 by Matthew Hildebrand     "
    "͵"
    " Although this demo is not particularly gripping, the power of The Graphics   "
    " Engine can be seen when it is run with different drivers:  the demo uses the "
    " same code to access different graphics modes.                                "
    "                                                                              "
    " Even if you don't want device-independence, but only one graphics mode, The  "
    " Graphics Engine's optimized assembler routines may be used.                  "
    "                                                                              "
    " The Graphics Engine costs a mere $25; paid users are entitled to free        "
    " upgrades and the use of any or all of the code, without royalties.  Refer to "
    " TGE.DOC for details.                                                         "
    "͵"
    " Matthew Hildebrand, 4 College St., St. Catharines, Ontario, Canada, L2R 2W7  "
    ""
    "\n"
  };

  printf(notice);
#else
  printf("Ŀ");
  printf(" The Graphics Engine v1.10 Demo  Copyright (c) 1993 by Matthew Hildebrand     ");
  printf("͵");
  printf(" Although this demo is not particularly gripping, the power of The Graphics   ");
  printf(" Engine can be seen when it is run with different drivers:  the demo uses the ");
  printf(" same code to access different graphics modes.                                ");
  printf("                                                                              ");
  printf(" Even if you don't want device-independence, but only one graphics mode, The  ");
  printf(" Graphics Engine's optimized assembler routines may be used.                  ");
  printf("                                                                              ");
  printf(" The Graphics Engine costs a mere $25; paid users are entitled to free        ");
  printf(" upgrades and the use of any or all of the code, without royalties.  Refer to ");
  printf(" TGE.DOC for details.                                                         ");
  printf("͵");
  printf(" Matthew Hildebrand, 4 College St., St. Catharines, Ontario, Canada, L2R 2W7  ");
  printf("\n");
#endif
}